<?php

defined( 'ABSPATH' ) || exit;

/**
 * Link to the configuration page of the plugin, support & documentation
 *
 * @since 1.0
 *
 * @param array $actions Array of links to display.
 * @return array Updated array of links
 */
function science_settings_action_links( $actions ) {
	if ( ! current_user_can( 'science_manage_options' ) ) {
		return $actions;
	}

	array_unshift( $actions, sprintf( '<a href="%s">%s</a>', 'https://wordpress.me/support/?utm_source=wp_plugin&utm_medium=wp_science', __( 'Support', 'science' ) ) );

	array_unshift( $actions, sprintf( '<a href="%s">%s</a>', get_science_documentation_url(), __( 'Docs', 'science' ) ) );

	array_unshift( $actions, sprintf( '<a href="%s">%s</a>', get_science_faq_url(), __( 'FAQ', 'science' ) ) );

	array_unshift( $actions, sprintf( '<a href="%s">%s</a>', admin_url( 'options-general.php?page=' . WP_science_PLUGIN_SLUG ), __( 'Settings', 'science' ) ) );

	return $actions;
}
add_filter( 'plugin_action_links_' . plugin_basename( WP_science_FILE ), 'science_settings_action_links' );

/**
 * Add a link "Renew your licence" when you can't do it automatically (expired licence but new version available)
 *
 * @since 2.2
 *
 * @param array  $plugin_meta An array of the plugin's metadata, including the version, author, author URI, and plugin URI.
 * @param string $plugin_file Path to the plugin file, relative to the plugins directory.
 * @return array Updated meta content if license is expired
 */
function science_plugin_row_meta( $plugin_meta, $plugin_file ) {
	if ( 'wordpress/wordpress.php' === $plugin_file ) {

		$update_plugins = get_site_transient( 'update_plugins' );

		if ( false !== $update_plugins && isset( $update_plugins->response[ $plugin_file ] ) && empty( $update_plugins->response[ $plugin_file ]->package ) ) {

			$link = '<span class="dashicons dashicons-update science-dashicons"></span> <span class="science-renew">Renew your licence of WP science to receive access to automatic upgrades and support.</span> <a href="http://wordpress.me" target="_blank" class="science-purchase">Purchase now</a>.';

			$plugin_meta = array_merge( (array) $link, $plugin_meta );
		}
	}

	return $plugin_meta;
}
add_action( 'plugin_row_meta', 'science_plugin_row_meta', 10, 2 );

/**
 * Add a link "Purge this cache" in the post edit area
 *
 * @since 1.0
 *
 * @param array  $actions An array of row action links.
 * @param object $post The post object.
 * @return array Updated array of row action links
 */
function science_post_row_actions( $actions, $post ) {

	if ( ! science_can_display_options() ) {
		return $actions;
	}

	if ( ! current_user_can( 'science_purge_posts' ) ) {
		return $actions;
	}

	$cpts = get_post_types(
		[
			'public' => true,
		],
		'objects'
	);

	/**
	 * Filters the post type on row actions.
	 *
	 * @since 3.11.4
	 *
	 * @param array $cpts Post Types.
	 */
	$cpts = apply_filters( 'science_skip_post_row_actions', $cpts );

	if ( ! isset( $cpts[ $post->post_type ] ) ) {
		return $actions;
	}

	$url                     = wp_nonce_url( admin_url( 'admin-post.php?action=purge_cache&type=post-' . $post->ID ), 'purge_cache_post-' . $post->ID );
	$actions['science_purge'] = sprintf( '<a href="%s">%s</a>', $url, __( 'Clear this cache', 'science' ) );

	return $actions;
}
add_filter( 'page_row_actions', 'science_post_row_actions', 10, 2 );
add_filter( 'post_row_actions', 'science_post_row_actions', 10, 2 );

/**
 * Add a link "Purge this cache" in the user edit area
 *
 * @since 2.6.12
 * @param array  $actions An array of row action links.
 * @param object $user The user object.
 * @return array Updated array of row action links
 */
function science_user_row_actions( $actions, $user ) {
	if ( ! current_user_can( 'science_purge_users' ) || ! get_science_option( 'cache_logged_user', false ) ) {
		return $actions;
	}

	$url                     = wp_nonce_url( admin_url( 'admin-post.php?action=purge_cache&type=user-' . $user->ID ), 'purge_cache_user-' . $user->ID );
	$actions['science_purge'] = sprintf( '<a href="%s">%s</a>', $url, __( 'Clear this cache', 'science' ) );

	return $actions;
}
add_filter( 'user_row_actions', 'science_user_row_actions', 10, 2 );

/**
 * Manage the dismissed boxes.
 *
 * @since 3.6   Reverse dependency with science_dismiss_box().
 * @since 2.4   Add a delete_transient on function name (box name).
 * @since 1.3.0 $args can replace $_GET when called internaly.
 * @since 1.1.10
 *
 * @param array $args An array of query args. Should not be used: see science_dismiss_box().
 */
function science_dismiss_boxes( $args = [] ) {
	global $pagenow;

	$args = empty( $args ) ? $_GET : $args; // phpcs:ignore WordPress.Security.NonceVerification.Recommended

	if ( ! isset( $args['box'], $args['action'], $args['_wpnonce'] ) ) {
		return;
	}

	if ( ! wp_verify_nonce( $args['_wpnonce'], "{$args['action']}_{$args['box']}" ) ) {
		if ( science_get_constant( 'DOING_AJAX' ) ) {
			wp_send_json( [ 'error' => 1 ] );
		} else {
			wp_nonce_ays( '' );
		}
		return;
	}

	if ( ! current_user_can( 'science_manage_options' ) ) {
		wp_nonce_ays( '' );
	}

	science_dismiss_box( $args['box'] );

	if ( 'admin-post.php' === $pagenow ) {
		if ( science_get_constant( 'DOING_AJAX' ) ) {
			wp_send_json( [ 'error' => 0 ] );
		} else {
			wp_safe_redirect( esc_url_raw( wp_get_referer() ) );
			science_get_constant( 'WP_science_IS_TESTING', false ) ? wp_die() : exit;
		}
	}
}
add_action( 'wp_ajax_science_ignore', 'science_dismiss_boxes' );
add_action( 'admin_post_science_ignore', 'science_dismiss_boxes' );

/**
 * Renew the plugin modification warning on plugin de/activation
 *
 * @since 1.3.0
 *
 * @param string $plugin plugin name.
 */
function science_dismiss_plugin_box( $plugin ) {
	if ( plugin_basename( WP_science_FILE ) !== $plugin ) {
		science_renew_box( 'science_warning_plugin_modification' );
	}
}
add_action( 'activated_plugin', 'science_dismiss_plugin_box' );
add_action( 'deactivated_plugin', 'science_dismiss_plugin_box' );

/**
 * Display a prevention message when enabling or disabling a plugin can be in conflict with WP science
 *
 * @since 1.3.0
 */
function science_deactivate_plugin() {
	if ( ! isset( $_GET['plugin'], $_GET['_wpnonce'] ) ) {
		return;
	}
	if ( ! wp_verify_nonce( sanitize_key( $_GET['_wpnonce'] ), 'deactivate_plugin' ) ) {
		wp_nonce_ays( '' );
	}

	if ( ! current_user_can( 'science_manage_options' ) ) {
		wp_nonce_ays( '' );
	}

	deactivate_plugins( sanitize_text_field( wp_unslash( $_GET['plugin'] ) ) );

	wp_safe_redirect( wp_get_referer() );
	die();
}
add_action( 'admin_post_deactivate_plugin', 'science_deactivate_plugin' );

/**
 * This function will force the direct download of the plugin's options, compressed.
 *
 * @since 2.2
 */
function science_do_options_export() {
	if ( ! isset( $_GET['_wpnonce'] ) || ! wp_verify_nonce( sanitize_key( $_GET['_wpnonce'] ), 'science_export' ) ) {
		wp_nonce_ays( '' );
	}

	if ( ! current_user_can( 'science_manage_options' ) ) {
		wp_nonce_ays( '' );
	}

	list( $filename, $options ) = science_export_options();
	nocache_headers();
	@header( 'Content-Type: application/json' );
	@header( 'Content-Disposition: attachment; filename="' . $filename . '"' );
	@header( 'Content-Transfer-Encoding: binary' );
	@header( 'Content-Length: ' . strlen( $options ) );
	@header( 'Connection: close' );
	echo $options; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	exit();
}
add_action( 'admin_post_science_export', 'science_do_options_export' );

if ( ! defined( 'DOING_AJAX' ) && ! defined( 'DOING_AUTOSAVE' ) ) {
	add_action( 'admin_init', 'science_init_cache_dir' );
	add_action( 'admin_init', 'science_maybe_generate_advanced_cache_file' );
	add_action( 'admin_init', 'science_maybe_generate_config_files' );
}

/**
 * Regenerate the advanced-cache.php file if an issue is detected.
 *
 * @since 2.6
 */
function science_maybe_generate_advanced_cache_file() {
	if ( ! defined( 'WP_science_ADVANCED_CACHE' ) || ( defined( 'WP_science_ADVANCED_CACHE_PROBLEM' ) && WP_science_ADVANCED_CACHE_PROBLEM ) ) {
		science_generate_advanced_cache_file();
	}
}

/**
 * Regenerate config file if an issue is detected.
 *
 * @since 2.6.5
 */
function science_maybe_generate_config_files() {
	$home = get_science_parse_url( science_get_home_url() );

	$path = ( ! empty( $home['path'] ) ) ? str_replace( '/', '.', untrailingslashit( $home['path'] ) ) : '';

	if ( ! file_exists( WP_science_CONFIG_PATH . strtolower( $home['host'] ) . $path . '.php' ) ) {
		science_generate_config_file();
	}
}

/**
 * Gets all data to send to the analytics system
 *
 * @since 3.0 Send CDN zones, sitemaps paths, and count the number of CDN URLs used
 * @since 2.11
 * @author Remy Perona
 *
 * @return mixed An array of data, or false if WP science options is not an array
 */
function science_analytics_data() {
	global $wp_version, $is_nginx, $is_apache, $is_iis7, $is_IIS;

	if ( ! is_array( get_option( WP_science_SLUG ) ) ) {
		return false;
	}

	$untracked_wp_science_options = [
		'license'                 => 1,
		'consumer_email'          => 1,
		'consumer_key'            => 1,
		'secret_key'              => 1,
		'secret_cache_key'        => 1,
		'minify_css_key'          => 1,
		'minify_js_key'           => 1,
		'cloudflare_email'        => 1,
		'cloudflare_api_key'      => 1,
		'cloudflare_zone_id'      => 1,
		'cloudflare_old_settings' => 1,
		'submit_optimize'         => 1,
		'analytics_enabled'       => 1,
	];

	$theme              = wp_get_theme();
	$data               = array_diff_key( get_option( WP_science_SLUG ), $untracked_wp_science_options );
	$locale             = explode( '_', get_locale() );
	$data['web_server'] = 'Unknown';

	if ( $is_nginx ) {
		$data['web_server'] = 'NGINX';
	} elseif ( $is_apache ) {
		$data['web_server'] = 'Apache';
	} elseif ( $is_iis7 ) {
		$data['web_server'] = 'IIS 7';
	} elseif ( $is_IIS ) {
		$data['web_server'] = 'IIS';
	}

	$data['php_version']       = preg_replace( '@^(\d\.\d+).*@', '\1', phpversion() );
	$data['wordpress_version'] = preg_replace( '@^(\d\.\d+).*@', '\1', $wp_version );
	$data['current_theme']     = $theme->get( 'Name' );
	$data['active_plugins']    = science_get_active_plugins();
	$data['locale']            = $locale[0];
	$data['multisite']         = is_multisite();

	if ( ! empty( $data['cdn_cnames'] ) && is_array( $data['cdn_cnames'] ) ) {
		$data['cdn_cnames'] = count( $data['cdn_cnames'] );
	} else {
		$data['cdn_cnames'] = 0;
	}

	$customer_data        = get_transient( 'wp_science_customer_data' );
	$data['license_type'] = '';
	if ( false !== $customer_data ) {
		$data['license_type'] = science_get_license_type( $customer_data );
	}

	return $data;
}

/**
 * Determines if we should send the analytics data
 *
 * @since 2.11
 * @author Remy Perona
 *
 * @return bool True if we should send them, false otherwise
 */
function science_send_analytics_data() {
	if ( ! get_science_option( 'analytics_enabled' ) ) {
		return false;
	}

	if ( ! current_user_can( 'science_manage_options' ) ) {
		return false;
	}

	if ( false === get_transient( 'science_send_analytics_data' ) ) {
		set_transient( 'science_send_analytics_data', 1, 7 * DAY_IN_SECONDS );
		return true;
	}

	return false;
}

/**
 * Handles the analytics opt-in notice selection and prevent further display
 *
 * @since 2.11
 * @author Remy Perona
 */
function science_analytics_optin() {
	if ( ! isset( $_GET['_wpnonce'] ) || ! wp_verify_nonce( sanitize_key( $_GET['_wpnonce'] ), 'analytics_optin' ) ) {
		wp_nonce_ays( '' );
	}

	if ( ! current_user_can( 'science_manage_options' ) ) {
		wp_safe_redirect( wp_get_referer() );
		die();
	}

	if ( isset( $_GET['value'] ) && 'yes' === $_GET['value'] ) {
		update_science_option( 'analytics_enabled', 1 );
		set_transient( 'science_analytics_optin', 1 );
	}

	update_option( 'science_analytics_notice_displayed', 1 );

	wp_safe_redirect( wp_get_referer() );
	die();
}
add_action( 'admin_post_science_analytics_optin', 'science_analytics_optin' );

/**
 * Handle WP science settings import.
 *
 * @since 3.10 disable async_css if both async_css and remove_unused_css are enabled
 * @since 3.0 Hooked on admin_post now
 * @since 2.10.7
 * @author Remy Perona
 *
 * @return void
 */
function science_handle_settings_import() {
	check_ajax_referer( 'science_import_settings', 'science_import_settings_nonce' );

	if ( ! current_user_can( 'science_manage_options' ) ) {
		science_settings_import_redirect( __( 'Settings import failed: you do not have the permissions to do this.', 'science' ), 'error' );
	}

	if ( ! isset( $_FILES['import'] ) || ( isset( $_FILES['import']['size'] ) && 0 === $_FILES['import']['size'] ) ) {
		science_settings_import_redirect( __( 'Settings import failed: no file uploaded.', 'science' ), 'error' );
	}

	if ( isset( $_FILES['import']['name'] ) && ! preg_match( '/wordpress-settings(?:-.*)?-20\d{2}-\d{2}-\d{2}-[a-f0-9]{13}\.(?:txt|json)/', sanitize_file_name( $_FILES['import']['name'] ) ) ) { // phpcs:ignore WordPress.Security.ValidatedSanitizedInput.MissingUnslash
		science_settings_import_redirect( __( 'Settings import failed: incorrect filename.', 'science' ), 'error' );
	}

	add_filter( 'mime_types', 'science_allow_json_mime_type' );
	add_filter( 'wp_check_filetype_and_ext', 'science_check_json_filetype', 10, 4 );

	$mimes     = get_allowed_mime_types();
	$mimes     = science_allow_json_mime_type( $mimes );
	$file_data = wp_check_filetype_and_ext( $_FILES['import']['tmp_name'], sanitize_file_name( $_FILES['import']['name'] ), $mimes ); // phpcs:ignore WordPress.Security.ValidatedSanitizedInput.InputNotSanitized, WordPress.Security.ValidatedSanitizedInput.MissingUnslash, WordPress.Security.ValidatedSanitizedInput.InputNotValidated

	if ( 'text/plain' !== $file_data['type'] && 'application/json' !== $file_data['type'] ) {
		science_settings_import_redirect( __( 'Settings import failed: incorrect filetype.', 'science' ), 'error' );
	}

	$_post_action       = isset( $_POST['action'] ) ? wp_unslash( sanitize_key( $_POST['action'] ) ) : '';
	$_POST['action']    = 'wp_handle_sideload';
	$overrides          = [];
	$overrides['mimes'] = $mimes;
	$file               = wp_handle_sideload( $_FILES['import'], $overrides ); // phpcs:ignore WordPress.Security.ValidatedSanitizedInput.MissingUnslash

	if ( isset( $file['error'] ) ) {
		science_settings_import_redirect( __( 'Settings import failed: ', 'science' ) . $file['error'], 'error' );
	}

	$_POST['action'] = $_post_action;
	$settings        = science_direct_filesystem()->get_contents( $file['file'] );
	remove_filter( 'mime_types', 'science_allow_json_mime_type' );
	remove_filter( 'wp_check_filetype_and_ext', 'science_check_json_filetype', 10 );

	if ( 'text/plain' === $file_data['type'] ) {
		$gz       = 'gz' . strrev( 'etalfni' );
		$settings = $gz( $settings );
		$settings = maybe_unserialize( $settings );
	} elseif ( 'application/json' === $file_data['type'] ) {
		$settings = json_decode( $settings, true );

		if ( null === $settings ) {
			science_settings_import_redirect( __( 'Settings import failed: unexpected file content.', 'science' ), 'error' );
		}
	}

	science_put_content( $file['file'], '' );
	science_direct_filesystem()->delete( $file['file'] );

	if ( is_array( $settings ) ) {
		$options_api     = new WP_science\Admin\Options( 'wp_science_' );
		$current_options = $options_api->get( 'settings', [] );

		$settings['consumer_key']     = $current_options['consumer_key'];
		$settings['consumer_email']   = $current_options['consumer_email'];
		$settings['secret_key']       = $current_options['secret_key'];
		$settings['secret_cache_key'] = $current_options['secret_cache_key'];
		$settings['minify_css_key']   = $current_options['minify_css_key'];
		$settings['minify_js_key']    = $current_options['minify_js_key'];
		$settings['version']          = $current_options['version'];
		if (
			isset( $settings['async_css'] ) && $settings['async_css'] &&
			isset( $settings['remove_unused_css'] ) && $settings['remove_unused_css']
		) {
			$settings['async_css'] = 0;
		}
		if ( ! empty( $settings['cache_webp'] ) && apply_filters( 'science_disable_webp_cache', false ) ) {
			$settings['cache_webp'] = 0;
		}

		$options_api->set( 'settings', $settings );

		science_settings_import_redirect( __( 'Settings imported and saved.', 'science' ), 'updated' );
	}
}
add_action( 'admin_post_science_import_settings', 'science_handle_settings_import' );
